unit dlg_patron;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls,utils,okcancl1;

type
  TDlgetiquettage = class(TOKbottomDlg)
    HelpBtn: TButton;
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ListBox1MeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
  resultat:string;
  libelles:string[4];
    { Public declarations }
  end;

var
  Dlgetiquettage: TDlgetiquettage;

implementation

{$R *.DFM}

procedure TDlgetiquettage.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(HelpContext);
end;

procedure TDlgetiquettage.FormShow(Sender: TObject);
begin
  inherited;
  resultat:='';
    ComboBox1.text:='';
    ComboBox2.text:='';
    listbox1.clear;
    listbox1.items.assign(modele[tag]);
    if listbox1.items.count=1 then listbox1.itemindex:=0;
  end;

procedure TDlgetiquettage.ComboBox1Change(Sender: TObject);
begin
  inherited;
if (combobox1.text<>'') and (combobox2.text<>'')
and (combobox1.text<>' ') and (combobox2.text<>' ')
then if combobox1.text=combobox2.text then
   begin
   application.messagebox('Vous ne pouvez pas spcifier 2 fois le mme lment.','Domaine',0);
   end;
   listbox1.refresh;
end;

procedure TDlgetiquettage.ListBox1MeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  inherited;
//width:=listbox1.clientwidth;
height:=clientwidth;
end;

procedure TDlgetiquettage.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
t:string[4];
i:byte;
begin
  inherited;
t:=copy(listbox1.items[index],1,4);
for i:=1 to 4 do
    begin
    if t[i]='.' then if (combobox1.text<>'') and (combobox1.text<>' ') then t[i]:=combobox1.text[1] else t[i]:=' ';
    if t[i]=':' then if (combobox2.text<>'') and (combobox2.text<>' ') then t[i]:=combobox2.text[1] else t[i]:=' ';
    end;
if odselected in state then
   begin
   listbox1.canvas.brush.color:=clhighlight;
   listbox1.canvas.font.color:=clhighlighttext;
   end;
listbox1.canvas.fillrect(rect);
if odselected in state then
dessinepatron(tag,listbox1.canvas,rect.top,rect.left,rect.right,rect.bottom,t,clhighlighttext)
else dessinepatron(tag,listbox1.canvas,rect.top,rect.left,rect.right,rect.bottom,t,clmenutext);
end;

procedure TDlgetiquettage.OKBtnClick(Sender: TObject);
var i:integer;
begin
  inherited;
modalresult:=mrnone;
if (combobox1.text='') or (combobox2.text='')
and (combobox1.text=' ') or (combobox2.text=' ') then
   begin
   application.messagebox('Vous devez spcifier les deux lments d''tiquettage.','Domaine',0);
   exit;
   end;
if combobox1.text=combobox2.text then
   begin
   application.messagebox('Vous ne pouvez pas spcifier 2 fois le mme lment.','Domaine',0);
   exit;
   end;
if listbox1.itemindex=-1 then
   begin
   application.messagebox('Vous devez indiquer la variante retenue.','Domaine',0);
   exit;
   end;
libelles:=copy(listbox1.items[listbox1.itemindex],1,4);
for i:=1 to 4 do
    begin
    if libelles[i]='.' then if (combobox1.text<>'') and (combobox1.text<>' ') then libelles[i]:=combobox1.text[1] else libelles[i]:=' ';
    if libelles[i]=':' then if (combobox2.text<>'') and (combobox2.text<>' ') then libelles[i]:=combobox2.text[1] else libelles[i]:=' ';
    end;
resultat:=copy(listbox1.items[listbox1.itemindex],5,length(listbox1.items[listbox1.itemindex])-4);
for i:=1 to length(resultat) do
    begin
    if resultat[i]='.' then if (combobox1.text<>'') and (combobox1.text<>' ') then resultat[i]:=combobox1.text[1];
    if resultat[i]=':' then if (combobox2.text<>'') and (combobox2.text<>' ') then resultat[i]:=combobox2.text[1];
    end;
modalresult:=mrok;

end;

end.

