unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,extctrls,
  ImgList, Menus,utils,dlg_patron, ComCtrls, StdCtrls,inifiles, Grids,graphes,mvsomt,clipbrd,printers,splashscreen;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Menu_Patrons: TMenuItem;
    StatusBar1: TStatusBar;
    Historique: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Liste_historique: TListBox;
    Nouveau1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrer1: TMenuItem;
    EnregistrerSous1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Ajouterunpatron: TMenuItem;
    Retirerunpatron: TMenuItem;
    PageControl1: TPageControl;
    Pagegraphique: TTabSheet;
    TabSheet2: TTabSheet;
    Surface_dessin: TScrollBox;
    DrawGrid1: TDrawGrid;
    Memo1: TMemo;
    Chronologie: TTabSheet;
    ImageList1: TImageList;
    N2: TMenuItem;
    AproposdeCTECA1: TMenuItem;
    Menu_Restrictions: TMenuItem;
    A1: TMenuItem;
    N3: TMenuItem;
    Copier1: TMenuItem;
    Graphique1: TMenuItem;
    Patronslectionn1: TMenuItem;
    Chronologie1: TMenuItem;
    Prcdences1: TMenuItem;
    N4: TMenuItem;
    Imprimer1: TMenuItem;
    Vueajuste1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Menu_PatronsMeasureItem(Sender: TObject; ACanvas: TCanvas;
      var Width, Height: Integer);
    procedure Menu_PatronsDrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure Menu_PatronsClick(Sender: TObject);
    procedure HistoriqueResize(Sender: TObject);
    procedure Liste_historiqueMeasureItem(Control: TWinControl;
      Index: Integer; var Height: Integer);
    procedure Liste_historiqueDrawItem(Control: TWinControl;
      Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure Nouveau1Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure EnregistrerSous1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure RetirerunpatronClick(Sender: TObject);
    procedure Liste_historiqueEnter(Sender: TObject);
    procedure Liste_historiqueExit(Sender: TObject);
    procedure Liste_historiqueClick(Sender: TObject);
    procedure Liste_historiqueMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure dessine_grille(canvas:tcanvas;ACol, ARow: Integer;Rect: TRect; State: TGridDrawState);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure AproposdeCTECA1Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure Surface_dessinClick(Sender: TObject);
    procedure Graphique1Click(Sender: TObject);
    procedure Patronslectionn1Click(Sender: TObject);
    procedure Chronologie1Click(Sender: TObject);
    procedure Prcdences1Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure Vueajuste1Click(Sender: TObject);
    procedure Surface_dessinResize(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

type Tchronologie=class(tgraphiccontrol)
  public
  procedure dessine(canvas:tcanvas);
  protected
    procedure Paint; override;
  published
    property Align;
  end;

type tpatron=class
     public
     numero:integer;
     libelles:string[4];
     end;


type Tgraphique=class(tgraphiccontrol)
  private
    FPen: TPen;
    procedure SetPen(Value: TPen);
  protected
    procedure Paint; override;
  public
  published
    procedure StyleChanged(Sender: TObject);
    property Align;
    property Anchors;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Constraints;
    property ParentShowHint;
    property Pen: TPen read FPen write SetPen;
    property ShowHint;
    property Visible;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;
const titre_defaut='C.T.E.C.A. ';
const modifications:boolean=false;
const annulation:boolean=false;
const fichier_courant:string='';
const vue_ajustee:boolean=false;
var
  Form1: TForm1;
  x:tgraphique;
  chrono:tchronologie;
  grille_principale:tgrille;
  graphique:tgraphe;
  elements_restrictions:array[0..25] of tmenuitem;


implementation

uses Apropos;
{$R *.DFM}


procedure imprime_graphique;
var
a1,A2,A3,a4:tpoint;
x:trect;
mm:integer;
begin
printer.begindoc;
with printer.canvas do
begin
x:=graphique.zoneoccupee;
mm:=getmapmode(handle);
setmapmode(handle,MM_ANISOTROPIC);
setwindoworgex(handle,x.left,x.top,nil);
setwindowextex(handle,x.right,x.bottom,nil);
setviewportorgex(handle,0,0,nil);
if printer.pagewidth>printer.pageheight then
setviewportextex(handle,printer.pagewidth,printer.pageheight,nil)
else setviewportextex(handle,printer.pagewidth,printer.pageheight div 2,nil)

end;
sortie_ecran:=false;
graphique.dessine(printer.canvas);
sortie_ecran:=true;
with printer.canvas do
begin
setmapmode(handle,mm);
setwindoworgex(handle,a1.x,a1.y,nil);
setwindowextex(handle,a2.x,a2.y,nil);
setviewportorgex(handle,a3.x,a3.y,nil);
setviewportextex(handle,a4.x,a4.y,nil);
end;
printer.enddoc;
end;


procedure copie_graphique();
var metafichier:tmetafile;
    canvasmetafichier:tmetafilecanvas;
rect:trect;
s_fond:boolean;
begin
s_fond:=fond_blanc;
fond_blanc:=false;
metafichier := TMetafile.Create;
rect:=graphique.zoneoccupee;
metafichier.width:=rect.right;
metafichier.height:=rect.bottom;
canvasmetafichier:=TMetafileCanvas.Create(metafichier, 0);
graphique.dessine(canvasmetafichier);
canvasmetafichier.free;
clipboard.assign(metafichier);
metafichier.free;
fond_blanc:=s_fond;
end;

procedure copie_patron();
var metafichier:tmetafile;
    canvasmetafichier:tmetafilecanvas;
rect:trect;
begin
if form1.liste_historique.itemindex=-1 then exit;
rect.left:=0;
rect.top:=0;
rect.right:=form1.liste_historique.width;
rect.bottom:=form1.liste_historique.itemheight;
metafichier := TMetafile.Create;
metafichier.width:=rect.right;
metafichier.height:=rect.bottom;
canvasmetafichier:=TMetafileCanvas.Create(metafichier, 0);
dessinepatron(tpatron(form1.liste_historique.items.objects[form1.liste_historique.itemindex]).numero,canvasmetafichier,rect.top,rect.left,rect.right,rect.bottom,
tpatron(form1.liste_historique.items.objects[form1.liste_historique.itemindex]).libelles,clblack);
canvasmetafichier.free;
clipboard.assign(metafichier);
metafichier.free;
end;

procedure copie_chrono();
var metafichier:tmetafile;
    canvasmetafichier:tmetafilecanvas;
rect:trect;
begin
if chrono=nil  then exit;
rect.left:=0;
rect.top:=0;
rect.right:=chrono.width;
rect.bottom:=chrono.height;
metafichier := TMetafile.Create;
metafichier.width:=rect.right;
metafichier.height:=rect.bottom;
canvasmetafichier:=TMetafileCanvas.Create(metafichier, 0);
chrono.dessine(canvasmetafichier);
canvasmetafichier.free;
clipboard.assign(metafichier);
metafichier.free;
end;


procedure copie_grille();
var metafichier:tmetafile;
    canvasmetafichier:tmetafilecanvas;
rect:trect;
i,j:integer;
x:tcanvas;
begin
rect.left:=0;
rect.top:=0;
rect.right:=1;
for i:=0 to form1.DrawGrid1.Colcount-1 do
    rect.right:=rect.right+1+form1.drawgrid1.colwidths[i];
rect.bottom:=1;
for i:=0 to form1.DrawGrid1.rowcount-1 do
    rect.bottom:=rect.bottom+1+form1.drawgrid1.rowheights[i];
metafichier := TMetafile.Create;
metafichier.width:=rect.right;
metafichier.height:=rect.bottom;
canvasmetafichier:=TMetafileCanvas.Create(metafichier, 0);
rect.left:=0;
rect.right:=0;
rect.top:=0;
rect.bottom:=0;
for i:=0 to form1.drawgrid1.colcount-1 do
    begin
    rect.right:=rect.left+form1.drawgrid1.colwidths[i];
    rect.top:=0;
    for j:=0 to form1.drawgrid1.rowcount-1 do
        begin
        rect.bottom:=rect.top+form1.drawgrid1.rowheights[j];
        Form1.dessine_grille(canvasmetafichier, i, j, rect, []);;
        rect.top:=rect.bottom+1;
        end;
    rect.left:=rect.right+1;
    end;
canvasmetafichier.free;
clipboard.assign(metafichier);
metafichier.free;
end;

procedure tchronologie.dessine(canvas:tcanvas);
var
nbcolonnes,nblignes,ecart_x,ecart_y,taille_point:integer;
min,max,i,j,k:integer;
begin
with canvas do
begin
brush.style:=bssolid;
brush.color:=clwhite;
FillRect(clientrect);
end;
if graphique=nil then exit;
if graphique.max<=0 then exit;
max:=-1;
for i:=0 to graphique.max_sommets do
    begin
    j:=((graphique.sommets[i].point_de_depart(depart_general).x+ graphique.sommets[i].point_d_ancrage.x) div 2) div granularite +1;
    if j>max then max:=j;
    end;
nbcolonnes:=j;
if nbcolonnes=0 then exit;
ecart_x:=width div max;
j:=0;
for i:=0 to 25 do if (grille_principale.domaine[i]) and not (grille_principale.restrictions[i]) then j:=j+1;
nblignes:=j;
if nblignes=0 then exit;
j:=j+1;
ecart_y:=height div j;
if ecart_x<ecart_y then taille_point:=ecart_x div 10 else taille_point:=ecart_y div 10;
with canvas do
     begin
     pen.style:=psdot;
     for i:=1 to nbcolonnes+2 do
         begin
         moveto(i*ecart_x,0);
         lineto(i*ecart_x,height);
         end;
     for i:=1 to nblignes+2 do
         begin
         moveto(0,i*ecart_y);
         lineto(width,i*ecart_y);
         end;
     j:=0;
     for k:=0 to 25 do if grille_principale.domaine[k] and not (grille_principale.restrictions[k]) then
         begin
         j:=j+ecart_y;
         brush.style:=bssolid;
         brush.color:=clwhite;
         font.name:='Arial';
         font.size:=taille_point*4;
         textout(0,j-textheight(chr(integer('A')+k)) div 2,chr(integer('A')+k));

         for i:=0 to graphique.max_sommets do if pos(chr(integer('A')+k)+'-',graphique.sommets[i].etiquettes)<>0 then
             begin
             min:=((graphique.sommets[i].point_de_depart(depart_general).x+ graphique.sommets[i].point_d_ancrage.x) div 2) div granularite +1;
             break;
             end;
         for i:=0 to graphique.max_sommets do if pos(chr(integer('A')+k)+'+',graphique.sommets[i].etiquettes)<>0 then
             begin
             max:=((graphique.sommets[i].point_de_depart(depart_general).x+ graphique.sommets[i].point_d_ancrage.x) div 2) div granularite +1;
             break;
             end;
         min:=(min-1)*ecart_x;
         max:=(max-1)*ecart_x;
         brush.style:=bssolid;
         brush.color:=clblack;
         rectangle(min,j-taille_point,max,j+taille_point);
         end;
     end;

end;

procedure tchronologie.paint();
begin
dessine(canvas);
end;


procedure compose_erreurs(i:integer;s:string);
var
u1,u2:char;
s1,s2:string;
t1,t2,v:string;
begin
while length(s)>=6 do
      begin
      v:='Patron n'+inttostr(i)+' : ';
      t1:=copy(s,1,2);
      t2:=copy(s,3,2);
      u1:=s[5];
      u2:=s[6];
      case u1 of
           '<' : s1:=' est antrieur  ';
           '>' : s1:=' est postrieur  ';
           inf_egal : s1:= ' est antrieur ou gal  ';
           sup_egal : s1:= ' est posterieur ou gal  ';
           '=' : s1:=' est simultan  ';
           end;
      case u2 of
           '<' : s2:=' etait antrieur  ';
           '>' : s2:=' etait postrieur  ';
           inf_egal : s2:= ' etait antrieur ou gal  ';
           sup_egal : s2:= ' etait posterieur ou gal  ';
           '=' : s2:=' etait simultan  ';
           end;
      v:=v+t1+s1+t2+'; or une dclaration prcdente indiquait que '+t1+s2+t2+'.';
      form1.memo1.lines.add(v);
      form1.memo1.lines.add('');
      delete(s,1,6);
      end;

end;


procedure calcule;
var
r:trect;
i:integer;
begin
grille_principale.initialise;
for i:=0 to 25 do if elements_restrictions[i]<>nil then
    if elements_restrictions[i].checked then grille_principale.restrictions[i]:=true;
graphique.reinitialise;
form1.memo1.text:='';
form1.memo1.height:=0;
for i:=0 to form1.liste_historique.items.count-1 do
    begin
    grille_principale.construit_d_apres_chaine(form1.liste_historique.items[i]);
    if grille_principale.erreurs<>'' then compose_erreurs(i+1,grille_principale.erreurs);
    grille_principale.erreurs:='';
    end;
for i:=0 to 25 do with form1.drawgrid1 do
    if (grille_principale.domaine[i]=false) or  grille_principale.restrictions[i] then
       begin
       colwidths[i*2+1]:=-1;
       colwidths[i*2+2]:=-1;
       rowheights[i*2+1]:=-1;
       rowheights[i*2+2]:=-1;
       end
       else
       begin
       colwidths[i*2+1]:=defaultcolwidth;
       colwidths[i*2+2]:=defaultcolwidth;
       rowheights[i*2+1]:=defaultrowheight;
       rowheights[i*2+2]:=defaultrowheight;
       end;
if form1.drawgrid1.visible then form1.drawgrid1.repaint;
if form1.memo1.text<>'' then
   begin
   form1.memo1.height:=form1.panel2.clientheight;
   form1.font.color:=clblack;
   form1.repaint;
   exit;
   end;
graphique.initialise_d_apres_grille(grille_principale);
if x<>nil then x.invalidate;
if chrono<>nil then chrono.setbounds(form1.chronologie.clientrect.left,form1.chronologie.clientrect.top,form1.chronologie.clientrect.right,form1.chronologie.clientrect.bottom);
if chrono<>nil then chrono.repaint;
//form1.chronologie.invalidate;
form1.statusbar1.simpletext:=graphique.equivalent_ponctuel;
form1.statusbar1.hint:=graphique.equivalent_ponctuel;
if not(vue_ajustee) then
begin
r:=graphique.zoneoccupee;
form1.surface_dessin.horzscrollbar.range:=r.Right;
form1.surface_dessin.vertscrollbar.range:=r.bottom;
end
else
begin
form1.surface_dessin.horzscrollbar.range:=form1.surface_dessin.clientwidth;
form1.surface_dessin.vertscrollbar.range:=form1.surface_dessin.clientheight;
end;
end;


procedure Tgraphique.StyleChanged(Sender: TObject);
begin
  Invalidate;
end;

procedure Tgraphique.SetPen(Value: TPen);
begin
  FPen.Assign(Value);
end;


procedure Tgraphique.paint();
var
x:trect;
mm:integer;
a1,a2,a3,a4:tpoint;
begin
if vue_ajustee then
begin
with canvas do
begin
brush.style:=bssolid;
brush.color:=clwhite;
mm:=getmapmode(handle);;
setmapmode(handle,MM_ISOTROPIC);
setwindoworgex(handle,0,0,@a1);
setwindowextex(handle,parent.clientwidth,parent.clientheight,@a2);
setviewportorgex(handle,0,0,@a3);
setviewportextex(handle,parent.clientwidth,parent.clientheight,@a4);
FillRect(x);
end;
if parent<>nil then if parent.visible then if graphique<>nil then
with canvas do if grille_principale.source<>'' then
begin
x.left:=0;
x.left:=0;
x.right:=parent.clientwidth;
x.bottom:=parent.clientheight;
x:=graphique.zoneoccupee;
setmapmode(handle,MM_ANISOTROPIC);
setwindoworgex(handle,x.left,x.top,nil);
setwindowextex(handle,x.right,x.bottom,nil);
setviewportorgex(handle,0,0,nil);
setviewportextex(handle,parent.clientwidth,parent.clientheight,nil);
graphique.dessine(canvas);
end;
with canvas do
begin
setmapmode(handle,mm);
setwindoworgex(handle,a1.x,a1.y,nil);
setwindowextex(handle,a2.x,a2.y,nil);
setviewportorgex(handle,a3.x,a3.y,nil);
setviewportextex(handle,a4.x,a4.y,nil);
end;
end
else
begin
graphique.dessine(canvas);
end

end;


procedure sauvegarde(fichier:string);
var
x:tinifile;
i:integer;
begin
x:=tinifile.create(fichier);
x.erasesection('Preferences');
x.erasesection('Modele');
with form1.liste_historique do for i:=0 to items.count-1 do
     begin
     x.writeinteger('Modele','Patron '+inttostr(i)+' numero',tpatron(items.objects[i]).numero);
     x.writestring('Modele','Patron '+inttostr(i)+' libelles',tpatron(items.objects[i]).libelles);
     x.writestring('Modele','Patron '+inttostr(i)+' valeur',items[i]);
     end;
x.free;
form1.caption:=titre_defaut +' - '+fichier;
application.title:=form1.caption;
modifications:=false;
fichier_courant:=fichier;
end;


function nouveau:boolean;
var i:integer;
begin
result:=true;
if modifications then
   begin
   i:= application.messagebox('Les donnes du modle courant seront perdues, dsirez-vous les enregistrer au pralable ?',titre_defaut,MB_YESNOCANCEL+MB_DEFBUTTON1);
   if i=IDCANCEL then
      begin
      result:=false;
      exit;
      end;
   if i=IDYES then
   if fichier_courant<>'' then sauvegarde(fichier_courant) else
   begin
   form1.savedialog1.filename:=fichier_courant;
   if form1.savedialog1.execute then
      sauvegarde(form1.savedialog1.filename);
   end;
   end;
with form1.liste_historique do
begin
for i:=0 to items.count-1 do
     begin
     tpatron(items.objects[i]).free;
     end;
for i:=0 to 25 do if elements_restrictions[i]<>nil then
    if elements_restrictions[i].checked then elements_restrictions[i].checked:=false;
clear;
repaint;
end;
form1.caption:=titre_defaut;
application.title:=form1.caption;
fichier_courant:='';
modifications:=false;
end;



procedure ouverture(fichier:string);
var
x:tinifile;
i:integer;
numero:integer;
libelles,valeur:string;
y:tpatron;
begin
x:=tinifile.create(fichier);
i:=0;
with form1.liste_historique do
     begin
     while x.readinteger('Modele','Patron '+inttostr(i)+' numero',-1)<>-1 do
     begin
     numero:=x.readinteger('Modele','Patron '+inttostr(i)+' numero',0);
     libelles:=x.readstring('Modele','Patron '+inttostr(i)+' libelles','');
     valeur:=x.readstring('Modele','Patron '+inttostr(i)+' valeur','');
     y:=tpatron.create;
     y.numero:=numero;
     y.libelles:=libelles;
     items.objects[items.add(valeur)]:=y;
     i:=i+1;
     end;
     repaint;
     end;
x.free;
form1.caption:=titre_defaut +' - '+fichier;
application.title:=form1.caption;
fichier_courant:=fichier;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i,j:integer;
y:tmenuitem;
z:tmenuitem;
compteur:integer;
begin
chronologie.hint:='Cette chronologie est'#10+
                  'uniquement valable'#10+
                  'sous l''hyphothse de'#10+
                  'minimisation du nombre'#10+
                  'd''instants crs !';
chronologie.parentshowhint:=false;
grille_principale:=tgrille.create;
graphique:=tgraphe.create;
calcule;
form1.caption:=titre_defaut;
application.title:=form1.caption;
nouveau;
chrono:=tchronologie.create(self);
chrono.visible:=true;
chronologie.insertcontrol(chrono);
chrono.align:=alclient;
x:=tgraphique.create(self);
surface_dessin.insertcontrol (x);
surface_dessin.enabled:=true;
x.align:=alnone;
x.left:=0;
x.top:=0;
x.width:=2000;
x.height:=2000;
x.onclick:=Surface_dessinclick;
Menu_patrons.OnMeasureItem:=nil;
Menu_patrons.OnDrawItem:=nil;
Menu_patrons.OnClick:=nil;
Ajouterunpatron.OnMeasureItem:=nil;
Ajouterunpatron.OnDrawItem:=nil;
Ajouterunpatron.OnClick:=nil;
Retirerunpatron.OnMeasureItem:=nil;
Retirerunpatron.OnDrawItem:=nil;
Retirerunpatron.enabled:=false;
for i:=1 to 15 do
    begin
    y:=tmenuitem.create(self);
    y.caption:='&'+chr(64+i);
    y.tag:=classe[i];
    y.onmeasureitem:=Menu_PatronsMeasureItem;
    y.ondrawitem:=Menu_PatronsDrawItem;
    compteur:=0;
    if nbinstancesclassepatron[i]=1 then
    y.onclick:=Menu_PatronsClick
    else
    for j:=1 to high(classepatron) do
        if classepatron[j]=i then
           begin
           z:=tmenuitem.create(self);
           z.caption:=' '+chr(64+i)+chr(49+compteur);
           z.tag:=j;
           z.onmeasureitem:=Menu_PatronsMeasureItem;
           z.ondrawitem:=Menu_PatronsDrawItem;
           z.onclick:=Menu_PatronsClick;
           y.add(z);
           inc(compteur);
           end;
    Ajouterunpatron.add(y);
    end;
menu_restrictions.delete(0);
for i:=0 to 25 do
    begin
    elements_restrictions[i] :=tmenuitem.create(self);
    with elements_restrictions[i] do
         begin
         tag:=i+1000;
         caption:='&'+chr(integer('A')+i);
         radioitem:=false;
         visible:=true;
         onclick:=A1Click;
         onmeasureitem:=Menu_PatronsMeasureItem;
         ondrawitem:=menu_patronsdrawitem;
         end;
    menu_restrictions.add(elements_restrictions[i]);
    end;
screen.cursor:=crarrow;
splash.close;
end;

procedure TForm1.Menu_PatronsMeasureItem(Sender: TObject; ACanvas: TCanvas;
  var Width, Height: Integer);
begin
if ((sender as tmenuitem).tag>=1000) and ((sender as tmenuitem).tag<=1025) then
   begin
   Width:=height+width+1+acanvas.textwidth(copy(tmenuitem(sender).caption,2,2));
//   height:=acanvas.textheight(copy(tmenuitem(sender).caption,2,2));
   exit;
   end;
Width:=160+acanvas.textwidth(copy(tmenuitem(sender).caption,2,2));
Height:=96;
if height<acanvas.textheight(copy(tmenuitem(sender).caption,2,2)) then
height:=acanvas.textheight(copy(tmenuitem(sender).caption,2,2));
end;

procedure TForm1.Menu_PatronsDrawItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
begin
if (sender as tmenuitem).tag=0 then exit;
if ((sender as tmenuitem).tag>=1000) and ((sender as tmenuitem).tag<=1025) then
   begin
   if selected then
   begin
   acanvas.brush.color:=clhighlight;
   font.color:=clhighlighttext;
   end;
   acanvas.fillrect(arect);
   if (sender as tmenuitem).checked then
      begin
      acanvas.brush.style:=bssolid;
      acanvas.brush.color:=clred;
      ellipse(acanvas.handle,arect.left+1,arect.top+1,arect.left+(arect.bottom-arect.top)-1,arect.bottom-1);
      acanvas.brush.color:=clwhite;
      rectangle(acanvas.handle,arect.left+4,arect.top+(arect.bottom-arect.top) div 2-2,arect.left+(arect.bottom-arect.top)-4,arect.bottom-(arect.bottom-arect.top) div 2+2);
      acanvas.brush.style:=bsclear;
      if selected then acanvas.brush.color:=clhighlight else acanvas.brush.color:=clmenu;
      end;
   acanvas.textout(arect.left+(arect.bottom-arect.top)+1,arect.top+(arect.bottom-arect.top-acanvas.textheight(copy(tmenuitem(sender).caption,2,1))) div 2,copy(tmenuitem(sender).caption,2,2));
   exit;
   end;
if selected then
   begin
   acanvas.brush.color:=clhighlight;
   font.color:=clhighlighttext;
   end;
acanvas.fillrect(arect);
acanvas.textout(arect.left,arect.top+(arect.bottom-arect.top-acanvas.textheight(copy(tmenuitem(sender).caption,2,1))) div 2,copy(tmenuitem(sender).caption,2,2));
arect.left:=arect.left+acanvas.textwidth(copy(tmenuitem(sender).caption,2,2));
if selected then
dessinepatron(tmenuitem(sender).tag,acanvas,arect.top,arect.left,arect.right,arect.bottom,'',clhighlighttext)
else dessinepatron(tmenuitem(sender).tag,acanvas,arect.top,arect.left,arect.right,arect.bottom,'',clmenutext);
end;

procedure TForm1.Menu_PatronsClick(Sender: TObject);
var y:tpatron;
begin
if (sender as tmenuitem).tag=0 then exit;
if modele[(sender as tmenuitem).tag]<>nil then
begin
Dlgetiquettage.tag:=(sender as tmenuitem).tag;
if Dlgetiquettage.showmodal<>mrOK then exit;
end;
y:=tpatron.create;
y.numero:=(sender as tmenuitem).tag;
y.libelles:=dlgetiquettage.libelles;
liste_historique.items.objects[liste_historique.items.add(Dlgetiquettage.resultat)]:=y;
liste_historique.repaint;
statusbar1.simpletext:=Dlgetiquettage.resultat;
calcule;
modifications:=true;
end;

procedure TForm1.HistoriqueResize(Sender: TObject);
begin
liste_historique.itemheight:=2*liste_historique.width div 3;
liste_historique.invalidate;
liste_historique.repaint;
end;

procedure TForm1.Liste_historiqueMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
height:=2*liste_historique.width div 3;
end;

procedure TForm1.Liste_historiqueDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
t:string;
begin
t:=copy(tpatron(liste_historique.items.objects[Index]).libelles,1,4);
liste_historique.canvas.font.color:=clwindowtext;
if odselected in state then
   begin
   liste_historique.canvas.brush.color:=clhighlight;
   liste_historique.canvas.font.color:=clhighlighttext;
   end;
liste_historique.canvas.fillrect(rect);
liste_historique.canvas.textout(rect.left,rect.top,'Patron n'+inttostr(index+1)+':');
if odselected in state then
dessinepatron(tpatron(liste_historique.items.objects[Index]).numero,liste_historique.canvas,rect.top,rect.left,rect.right,rect.bottom,t,clhighlighttext)
else dessinepatron(tpatron(liste_historique.items.objects[Index]).numero,liste_historique.canvas,rect.top,rect.left,rect.right,rect.bottom,t,clmenutext);
end;

procedure TForm1.Nouveau1Click(Sender: TObject);
begin
nouveau;
calcule;
end;

procedure TForm1.Ouvrir1Click(Sender: TObject);
begin
if not nouveau then exit;
opendialog1.filename:='';
if opendialog1.execute then ouverture(opendialog1.filename);
calcule;
end;


procedure TForm1.Enregistrer1Click(Sender: TObject);
begin
if fichier_courant='' then EnregistrerSous1Click(Sender)
else sauvegarde(fichier_courant);
end;

procedure TForm1.EnregistrerSous1Click(Sender: TObject);
begin
savedialog1.filename:='*.mod';
if savedialog1.execute then
   sauvegarde(savedialog1.filename);
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
close;
end;

procedure TForm1.RetirerunpatronClick(Sender: TObject);
begin
if liste_historique.items.count >0  then if liste_historique.itemindex<>-1 then
     begin
     tpatron(liste_historique.items.objects[liste_historique.itemindex]).free;
     liste_historique.items.delete(liste_historique.itemindex);
     end;
if (liste_historique.items.count=0) or (liste_historique.itemindex=-1) then retirerunpatron.enabled:=false else
retirerunpatron.enabled:=true;
calcule;
modifications:=true;
end;

procedure TForm1.Liste_historiqueEnter(Sender: TObject);
begin
if (liste_historique.items.count=0) or (liste_historique.itemindex=-1) then retirerunpatron.enabled:=false else
retirerunpatron.enabled:=true;
end;

procedure TForm1.Liste_historiqueExit(Sender: TObject);
begin
retirerunpatron.enabled:=false;
end;

procedure TForm1.Liste_historiqueClick(Sender: TObject);
begin

if (liste_historique.items.count=0) or (liste_historique.itemindex=-1) then retirerunpatron.enabled:=false else
retirerunpatron.enabled:=true;
end;

procedure TForm1.Liste_historiqueMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var position:integer;
point:tpoint;
begin
point.x:=x;
point.y:=y;
position:=liste_historique.itematpos(point,true);
liste_historique.showhint:=position<>-1;
if position<>-1 then liste_historique.hint:=liste_historique.items[position]
   else liste_historique.hint:='';
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
canclose:=nouveau;
if canclose then freeconsole;
end;

procedure tform1.dessine_grille(canvas:tcanvas;ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var i:integer;
s,t:string;
u:char;
begin
if grille_principale=nil then exit;
if (acol=0) and (arow=0) then exit;
with Drawgrid1 do
     if (colwidths[acol]<=0) or (rowheights[arow]<=0) then exit;
with canvas do
     begin
     if acol=arow then
        begin
        brush.style:=bssolid;
        brush.color:=clbtnface;
        fillrect(rect);
        brush.color:=clwhite;
        exit;
        end;
     if (acol=0) or (arow=0) then
        begin
        font.name:='Arial';
        Font.size:=9;
        if acol=0 then i:=arow-1 else i:=acol-1;
        s:=chr(byte('A')+(i div 2));
        if (i and 1)=1 then s:=s+'+' else s:=s+'-';
        end
        else
        begin
        font.size:=13;
        i:=arow-1;
        s:=chr(byte('A')+(i div 2));
        if (i and 1)=1 then s:=s+'+' else s:=s+'-';
        i:=acol-1;
        t:=chr(byte('A')+(i div 2));
        if (i and 1)=1 then t:=t+'+' else t:=t+'-';
        u:=grille_principale[s,t];
        font.name:='Symbol';
        s:=u;
        if u=inf_egal then
           begin
           font.name:='Symbol';
           s:='';
           end;
        if u=sup_egal then
           begin
           font.name:='Symbol';
           s:=#179;
           end;
        end;
        font.color:=clblack;
        textrect(rect,rect.left+(rect.right-rect.left-textwidth(s)) div 2,rect.top+(rect.bottom-rect.top-textheight(s)) div 2,s);
        end;
end;


procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
dessine_grille(drawgrid1.canvas,acol,arow,rect,state);
end;

procedure TForm1.AproposdeCTECA1Click(Sender: TObject);
begin
aboutbox.showmodal;
end;

procedure TForm1.A1Click(Sender: TObject);
begin
with (sender as tmenuitem) do
begin
checked:=not checked;
end;
calcule;
end;

procedure TForm1.Surface_dessinClick(Sender: TObject);
var i:integer;
possouris:tpoint;
r:trect;
begin
if vue_ajustee then exit;
getcursorpos(possouris);
possouris:=x.screentoclient(possouris);
with graphique do
for i:=0 to max_sommets do
    begin
    r:=sommets[i].zoneoccupee;
    if (possouris.x>=r.left) and
       (possouris.x<=r.right) and
       (possouris.y>=r.top) and
       (possouris.y<=r.bottom) then
       begin
       OKRightDlg.Caption:='('+sommets[i].etiquettes+')';
       OKRightDlg.position.value:=0;
       if OKRightDlg.showmodal =mrok then
          begin
          sommets[i].translate(0,OKRightDlg.position.value);
          x.repaint;
          end;
       break;
       end;
    end;
end;

procedure TForm1.Graphique1Click(Sender: TObject);
begin
copie_graphique;
end;

procedure TForm1.Patronslectionn1Click(Sender: TObject);
begin
copie_patron;
end;

procedure TForm1.Chronologie1Click(Sender: TObject);
begin
copie_chrono;
end;

procedure TForm1.Prcdences1Click(Sender: TObject);
begin
copie_grille;
end;

procedure TForm1.Imprimer1Click(Sender: TObject);
begin
imprime_graphique;
end;

procedure TForm1.Vueajuste1Click(Sender: TObject);
var
r:trect;
begin
if not (vue_ajustee) then
   begin
   vue_ajustee:=true;
   (sender as tmenuitem).caption:='Vue normale';
   end
   else
   begin
   vue_ajustee:=false;
   (sender as tmenuitem).caption:='Vue ajuste';

   end;
if not(vue_ajustee) then
begin
r:=graphique.zoneoccupee;
form1.surface_dessin.horzscrollbar.range:=r.Right;
form1.surface_dessin.vertscrollbar.range:=r.bottom;
end
else
begin
form1.surface_dessin.horzscrollbar.range:=form1.surface_dessin.clientwidth;
form1.surface_dessin.vertscrollbar.range:=form1.surface_dessin.clientheight;
end;
surface_dessin.invalidate;
end;

procedure TForm1.Surface_dessinResize(Sender: TObject);
begin
x.Invalidate;
end;

end.
