unit utils;

interface

uses classes,graphics,windows,ODRegexp;

const classe:array[1..15] of byte=
(1,2,4,6,7,8,9,17,18,20,22,24,28,31,35);
const nbinstancesclassepatron:array[1..15] of byte=
(1,2,2,1,1,1,8,1,2,2,2,4,3,4,4);
const classepatron:array[1..38] of byte=
(1,2,2,3,3,4,5,6,7,7,7,7,7,7,7,7,8,
9,9,10,10,11,11,12,12,12,12,13,13,13,14,14,14,14,
15,15,15,15);

var modele:array[1..38] of tstringlist;

Procedure dessinepatron(numero:byte;canvas:tcanvas;top,left,width,height:integer;libelles:string;couleur:tcolor);
procedure dessinefleche(canvas:tcanvas;x1,y1,x2,y2,taille:integer);

const dessine_trait_supplementaire:boolean=true;

implementation

function cherchepatron(patron:string;var libelles:string):byte;
var
i,j:integer;
t:string;

function trouve(s1,s2:string):boolean;
var
i,j,k,l:integer;
begin
t:='';
for i:=1 to length(s1) do
    case s1[i] of
         '.',':' :t:=t+'.';
         '+' :t:=t+'[+]';
         else
         t:=t+s1[i];
         end;
t:=makepattern(t,1);
l:=find(s2,1,t,i,false);
if l<>0 then
   begin
   t:=copy(s1,1,4);
   delete(s1,1,4);
   i:=pos('.',s1);
   j:=pos(':',s1);
   if i<j then for k:=1 to 4 do
      if t[k]='.' then t[k]:=s2[l+i] else t[k]:=s2[l+j]
   else for k:=1 to 4 do
      if t[k]=':' then t[k]:=s2[l+i] else t[k]:=s2[l+j];
   end;
result:=l<>0;
end;


begin
for i:=1 to 38 do if modele[i]<>nil then for j:=0 to modele[i].count-1 do
    if trouve(patron,modele[i][j]) then
       begin
       cherchepatron:=i;
       libelles:=t;
       end;
end;



procedure initialise;
var
i:byte;
compteur:byte;

procedure aj(numero:byte;libelles,equivalent_ponctuel:string);
var
i:byte;
t:string;
begin

if modele[numero]=nil then modele[numero]:=tstringlist.create;
t:='';
for i:=1 to length(libelles) do
    if libelles[i]='a' then t:=t+'.' else t:=t+':';
for i:=1 to length(equivalent_ponctuel) do
    if equivalent_ponctuel[i]='a' then t:=t+'.' else
    if equivalent_ponctuel[i]='b' then t:=t+':' else t:=t+equivalent_ponctuel[i];
modele[numero].add(t);
end;


begin
for i:=1 to 38 do modele[i]:=nil;
aj(1,'abab','a-==b-<<a+==b+');
aj(2,'abab','a-==b-<<a+<<b+');
aj(2,'abba','a-==b-<<b+<<a+');
aj(3,'abab','a-==b-<<a+<=b+');
aj(3,'abba','a-==b-<<b+<=a+');
aj(4,'abab','a-<<b-<<a+==b+');
aj(4,'baab','b-<<a-<<a+==b+');
aj(5,'abab','a-<=b-<<a+==b+');
aj(5,'baab','b-<=a-<<a+==b+');
aj(6,'abab','a-==b-<<a+  b-<<b+');
aj(7,'abab','a-<<a+==b+  b-<<b+');
aj(8,'aabb','a-<<a+==b-<<b+');
aj(8,'baba','b-<<a-==b+<<a+');
aj(9,'aabb','a-<<a+<<b-<<b+');
aj(9,'abab','a-<<b-<<a+<<b+');
aj(9,'baab','b-<<a-<<a+<<b+');
aj(9,'abba','a-<<b-<<b+<<a+');
aj(9,'baba','b-<<a-<<b+<<a+');
aj(9,'bbaa','b-<<b+<<a-<<a+');
aj(10,'abab','a-<=b-<<a+<<b+');
aj(10,'baab','b-<=a-<<a+<<b+');
aj(10,'abba','a-<=b-<<b+<<a+');
aj(10,'baba','b-<=a-<<b+<<a+');
aj(11,'aabb','a-<<a+<=b-<<b+');
aj(11,'abab','a-<<b-<=a+<<b-');
aj(11,'baba','b-<<a-<=b+<<a+');
aj(11,'bbaa','b-<<b+<=a-<<a+');
aj(12,'abab','a-<<b-<<a+<=b+');
aj(12,'baab','b-<<a-<<a+<=b+');
aj(12,'abba','a-<<b-<<b+<=a+');
aj(12,'baba','b-<<a-<<b+<=a+');
aj(13,'abab','a-<=b-<=a+<<b+');
aj(13,'baba','b-<=a-<=b+<<a+');
aj(14,'abab','a-<=b-<<a+<=b+');
aj(14,'baab','b-<=a-<<a+<=b+');
aj(14,'abba','a-<=b-<<b+<=a+');
aj(14,'baba','b-<=a-<<b+<=a+');
aj(15,'abab','a-<<b-<=a+<=b+');
aj(15,'baba','b-<<a-<=b+<=a+');
if dessine_trait_supplementaire then
    begin
    aj(16,'abab','a-<=b-<=a+<=b+  a-<<a+  b-<<b+');
    aj(16,'baba','b-<=a-<=b+<=a+  b-<<b+  a-<<a+');
    end
    else
    begin
    aj(16,'abab','a-<=b-<=a+<=b+');
    aj(16,'baba','b-<=a-<=b+<=a+');
    end;
aj(17,'abab','a-<<a+  b-<<b+');
aj(18,'abab','a-<<a+  b-<<b+  a-<<b+');
aj(18,'baba','b-<<b+  a-<<a+  b-<<a+');
aj(19,'abab','a-<<a+  b-<<b+  a-<=b+');
aj(19,'baba','b-<<b+  a-<<a+  b-<=a+');
aj(20,'aabb','a-<<a+  a-<<b-<<b+');
aj(20,'bbaa','b-<<b+  b-<<a-<<a+');
aj(21,'aabb','a-<<a+  a-<=b-<<b+');
aj(21,'bbaa','b-<<b+  b-<=a-<<a+');
aj(22,'aabb','a-<<a+<<b+  b-<<b+');
aj(22,'bbaa','b-<<b+<<a+  a-<<a+');
aj(23,'aabb','a-<<a+<=b+  b-<<b+');
aj(23,'bbaa','b-<<b+<=a+  a-<<a+');
aj(24,'aabb','a-<<a+<<b+  a-<<b-<<b+');
aj(24,'bbaa','b-<<b+<<a+  b-<<a-<<a+');
aj(25,'aabb','a-<<a+<<b+  a-<=b-<<b+');
aj(25,'bbaa','b-<<b+<<a+  b-<=a-<<a+');
aj(26,'aabb','a-<<a+<=b+  a-<<b-<<b+');
aj(26,'bbaa','b-<<b+<=a+  b-<<a-<<a+');
aj(27,'aabb','a-<<a+<=b+  a-<=b-<<b+');
aj(27,'bbaa','b-<<b+<=a+  b-<=a-<<a+');
aj(28,'abab','a-<<a+  b-<<b+  a-<<b+  b-<<a+');
aj(29,'abab','a-<<a+  b-<<b+  a-<=b+  b-<<a+');
aj(29,'baba','b-<<b+  a-<<a+  b-<=a+  a-<<b+');
aj(30,'abab','a-<<a+  b-<<b+  a-<=b+  b-<=a+');
aj(31,'abba','a-<<b-<<a+  b-<<b+');
aj(31,'baab','b-<<a-<<b+  a-<<a+');
aj(32,'abba','a-<=b-<<a+  b-<<b+');
aj(32,'baab','b-<=a-<<b+  a-<<a+');
aj(33,'abba','a-<<b-<=a+  b-<<b+');
aj(33,'baab','b-<<a-<=b+  a-<<a+');
if dessine_trait_supplementaire then
    begin
    aj(34,'abba','a-<=b-<=a+  b-<<b+  a-<<a+');
    aj(34,'baab','b-<=a-<=b+  a-<<a+  b-<<b+');
    end
    else
    begin
    aj(34,'abba','a-<=b-<=a+  b-<<b+');
    aj(34,'baab','b-<=a-<=b+  a-<<a+');
    end;
aj(35,'baba','a-<<b+<<a+  b-<<b+');
aj(35,'abab','b-<<a+<<b+  a-<<a+');
aj(36,'baba','a-<<b+<=a+  b-<<b+');
aj(36,'abab','b-<<a+<=b+  a-<<a+');
aj(37,'baba','a-<=b+<<a+  b-<<b+');
aj(37,'abab','b-<=a+<<b+  a-<<a+');
if dessine_trait_supplementaire then
    begin
    aj(38,'baba','a-<=b+<=a+  b-<<b+  a-<<a+');
    aj(38,'abab','b-<=a+<=b+  a-<<a+  b-<<b+');
    end
    else
    begin
    aj(38,'baba','a-<=b+<=a+  b-<<b+');
    aj(38,'abab','b-<=a+<=b+  a-<<a+');
    end;
end;

procedure finalise;
var
i:byte;
begin
for i:=1 to 38 do if modele[i]<>nil then modele[i].free;
end;

procedure dessinefleche(canvas:tcanvas;x1,y1,x2,y2,taille:integer);
var x3,y3,x4,y4,x3p,y3p,x4p,y4p:integer;
w:real;
a:integer;
begin
a:=1;
w:=0;
if (x1=x2) and (y1=y2) then exit;
if (x1=x2) then
   begin
   if (y1>y2) then w:=pi/2 else w:=3*pi/2;
   end
   else if (y1=y2) then
        begin
        if (x1>x2) then w:=0 else w:=0;
        end;
if (x1<>x2) then
   begin
   w:=w-arctan((y2-Y1)/(x2-x1));
   if x2<x1 then w:=w+pi;
   end;
w:=w+pi/2;
x3:=-taille;
y3:=a*taille div 2;
x4:=-taille;
y4:=-a*taille div 2;
x3p:=round(x3*sin(w)+y3*cos(w));
y3p:=round(x3*cos(w)-y3*sin(w));
x3p:=x3p+x2;
y3p:=y3p+y2;
x4p:=round(x4*sin(w)+y4*cos(w));
y4p:=round(x4*cos(w)-y4*sin(w));
x4p:=x4p+x2;
y4p:=y4p+y2;
with canvas do
     begin
     moveto(x1,y1);
     lineto(x2,Y2);
     pie(x2-taille,y2-taille,x2+taille,y2+taille,x3p,y3p,x4p,y4p);
     end;
end;



Procedure dessinepatron(numero:byte;canvas:tcanvas;top,left,width,height:integer;libelles:string;couleur:tcolor);
var
t:array[0..3] of tpoint;
ix,iy:integer;
tc:integer;
compteur:byte;

procedure point(x,y:integer);
          begin
          with canvas do
               begin
               brush.style:=bssolid;
               brush.color:=couleur;
               ellipse(left+x-tc,top+y-tc,left+x+tc,top+y+tc);
               if compteur<=length(libelles)
                  then
                  begin
                  brush.style:=bsclear;
                  font.color:=couleur;
                  font.Name:='Arial';
                  if tc>0 then font.size:=tc*2 else font.size:=4;
                  textout(left+x-textwidth(copy(libelles,compteur,1)) div 2,top+y-tc-textheight(copy(libelles,compteur,1)),copy(libelles,compteur,1));
                  end;
               inc(compteur);
               end;
          end;

procedure pointb(x,y:integer);
          begin
          with canvas do
               begin
               brush.style:=bssolid;
               brush.color:=couleur;
               ellipse(left+x-tc,top+y-tc,left+x+tc,top+y+tc);
               if compteur<=length(libelles)
                  then
                  begin
                  brush.style:=bsclear;
                  font.color:=couleur;
                  font.Name:='Arial';
                  if tc>0 then font.size:=tc*2 else font.size:=4;
                  textout(left+x-textwidth(copy(libelles,compteur,1)) div 2,top+y+tc{+textheight(copy(libelles,compteur,1))},copy(libelles,compteur,1));
                  end;
               inc(compteur);
               end;
          end;

procedure trait(x1,y1,x2,Y2:integer);
          begin
          with canvas do
               begin
               moveto(left+x1,top+y1);
               lineto(left+x2,top+Y2);
               end;
          end;

procedure traitsup(x1,y1,x2,Y2:integer);
          begin
          if not dessine_trait_supplementaire then exit;
          with canvas do
               begin
//               moveto(left+x1,top+y1);
               arc(left+x1,top+y1-3*tc,left+x2,top+Y2+3*tc,left+x1,top+y1,left+x2,top+Y2);
               lineto(left+x2,top+Y2);
               end;
          end;

procedure ensemble(x1,y1,x2,Y2:integer);
          begin
          with canvas do
               begin
               brush.style:=bsclear;
               ellipse(left+x1-5*tc,top+y1-5*tc,left+x2+5*tc,top+y2+5*tc);
               end;
          end;

{procedure fleche(x,y,orientation:integer);
var z:array[0..2]  of tpoint;

begin
     if orientation=0 then
        begin
        z[0].x:=left+x-tc;
        z[0].y:=top+y;
        z[1].x:=left+x-4*tc;
        z[1].y:=top+y-tc;
        z[2].x:=left+x-4*tc;
        z[2].y:=top+y+tc;
        end
        else if orientation=1 then
        begin
        z[0].x:=left+x;
        z[0].y:=top+y;
        z[1].x:=left+x-4*tc;
        z[1].y:=top+y-(iy div (ix div tc)) div 2;
        z[2].x:=left+x-3*tc;
        z[2].y:=top+y-6*(iy div (ix div tc)) div 2;
        end
        else
        begin
        z[0].x:=left+x;
        z[0].y:=top+y;
        z[1].x:=left+x-4*tc;
        z[1].y:=top+y+(iy div (ix div tc)) div 2;
        z[2].x:=left+x-3*tc;
        z[2].y:=top+y+6*(iy div (ix div tc)) div 2;
        end;

     with canvas do
          begin
          brush.style:=bssolid;
          brush.color:=couleur;
          polygon(z);
          end;
     end;
}
procedure fleche(x1,y1,x2,y2:integer);
begin
canvas.brush.style:=bssolid;
canvas.brush.color:=couleur;
dessinefleche(canvas,left+x1,top+y1,left+x2,top+y2,tc*3);
end;

begin
compteur:=1;
width:=width-left;
height:=height-top;
ix:=width div 6;
iy:=height div 4;
tc:=ix div 7;
with canvas do
     begin
     Pen.mode:=pmcopy;
     Pen.style:=pssolid;
     brush.color:=couleur;
     pen.color:=couleur;
     brush.style:=bssolid;
     case numero of
          1 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               ensemble(ix*2,iy div 2+iy,ix*2,iy div 2+iy*2);
               ensemble(ix*4,iy div 2+iy,ix*4,iy div 2+iy*2);
               trait(ix*2+tc*5,iy*2,ix*4-tc*5,iy*2);
               end;
          2 :  begin
               point(ix,iy div 2+iy);
               pointb(ix,iy div 2+iy*2);
               point(ix*3,iy*2);
               point(ix*5,iy*2);
               ensemble(ix,iy div 2+iy,ix,iy div 2+iy*2);
               trait(ix+tc*5,iy*2,ix*5,iy*2);
               end;
          3 :  begin
               point(ix,iy div 2+iy);
               pointb(ix,iy div 2+iy*2);
               point(ix*3,iy*2);
               point(ix*5,iy*2);
               ensemble(ix,iy div 2+iy,ix,iy div 2+iy*2);
               trait(ix+tc*5,iy*2,ix*5,iy*2);
               fleche(ix*3,iy*2,ix*5,iy*2);
               end;
          4 :  begin
               point(ix,iy*2);
               point(ix*3,iy*2);
               point(ix*5,iy div 2+iy);
               pointb(ix*5,iy div 2+iy*2);
               ensemble(ix*5,iy div 2+iy,ix*5,iy div 2+iy*2);
               trait(ix,iy*2,ix*5-tc*5,iy*2);
               end;
          5 :  begin
               point(ix,iy*2);
               point(ix*3,iy*2);
               point(ix*5,iy div 2+iy);
               pointb(ix*5,iy div 2+iy*2);
               ensemble(ix*5,iy div 2+iy,ix*5,iy div 2+iy*2);
               trait(ix,iy*2,ix*5-tc*5,iy*2);
               fleche(ix,iy*2,ix*3,iy*2);
               end;
          6 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               ensemble(ix*2,iy div 2+iy,ix*2,iy div 2+iy*2);
               trait(ix*2+round(tc*5*0.9),iy div 2+iy,ix*4,iy div 2+iy);
               trait(ix*2+round(tc*5*0.9),iy div 2+iy*2,ix*4,iy div 2+iy*2);
               end;
          7 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               ensemble(ix*4,iy div 2+iy,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4-round(tc*5*0.9),iy div 2+iy);
               trait(ix*2,iy div 2+iy*2,ix*4-round(tc*5*0.9),iy div 2+iy*2);
               end;
          8 :  begin
               point(ix,iy*2);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               point(ix*5,iy*2);
               ensemble(ix*3,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix,iy*2,ix*3-5*tc,iy*2);
               trait(ix*3+5*tc,iy*2,ix*5,iy*2);
               end;
          9 :  begin
               point(ix+ix div 2,iy*2);
               point(ix*2+ix div 2,iy*2);
               point(ix*3+ix div 2,iy*2);
               point(ix*4+ix div 2,iy*2);
               trait(ix+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               end;
          10 :  begin
               point(ix+ix div 2,iy*2);
               point(ix*2+ix div 2,iy*2);
               point(ix*3+ix div 2,iy*2);
               point(ix*4+ix div 2,iy*2);
               trait(ix+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               fleche(ix+ix div 2,iy*2,ix*2+ix div 2,iy*2);
               end;
          11 :  begin
               point(ix+ix div 2,iy*2);
               point(ix*2+ix div 2,iy*2);
               point(ix*3+ix div 2,iy*2);
               point(ix*4+ix div 2,iy*2);
               trait(ix+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               fleche(ix*2+ix div 2,iy*2,ix*3+ix div 2,iy*2);
               end;
          12 :  begin
               point(ix+ix div 2,iy*2);
               point(ix*2+ix div 2,iy*2);
               point(ix*3+ix div 2,iy*2);
               point(ix*4+ix div 2,iy*2);
               trait(ix+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               fleche(ix*3+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               end;
          13 :  begin
               point(ix+ix div 2,iy*2);
               point(ix*2+ix div 2,iy*2);
               point(ix*3+ix div 2,iy*2);
               point(ix*4+ix div 2,iy*2);
               trait(ix+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               fleche(ix+ix div 2,iy*2,ix*2+ix div 2,iy*2);
               fleche(ix*2+ix div 2,iy*2,ix*3+ix div 2,iy*2);
               traitsup(ix+ix div 2,iy*2,ix*3+ix div 2,iy*2);
               end;
          14 :  begin
               point(ix+ix div 2,iy*2);
               point(ix*2+ix div 2,iy*2);
               point(ix*3+ix div 2,iy*2);
               point(ix*4+ix div 2,iy*2);
               trait(ix+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               fleche(ix+ix div 2,iy*2,ix*2+ix div 2,iy*2);
               fleche(ix*3+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               end;
          15 :  begin
               point(ix+ix div 2,iy*2);
               point(ix*2+ix div 2,iy*2);
               point(ix*3+ix div 2,iy*2);
               point(ix*4+ix div 2,iy*2);
               trait(ix+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               fleche(ix*2+ix div 2,iy*2,ix*3+ix div 2,iy*2);
               fleche(ix*3+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               traitsup(ix*2+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               end;
          16 :  begin
               point(ix+ix div 2,iy*2);
               point(ix*2+ix div 2,iy*2);
               point(ix*3+ix div 2,iy*2);
               point(ix*4+ix div 2,iy*2);
               trait(ix+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               fleche(ix+ix div 2,iy*2,ix*2+ix div 2,iy*2);
               fleche(ix*2+ix div 2,iy*2,ix*3+ix div 2,iy*2);
               fleche(ix*3+ix div 2,iy*2,ix*4+ix div 2,iy*2);
               end;
          17 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy*2);
               end;
          18 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy*2);
               end;
          19 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy*2);
               fleche(ix*2,iy div 2+iy,ix*4,iy div 2+iy*2);
               end;
          20 :  begin
               point(ix,iy div 2+iy);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;
          21 :  begin
               point(ix,iy div 2+iy);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               end;
          22 :  begin
               point(ix,iy div 2+iy);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy);
               trait(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;
          23 :  begin
               point(ix,iy div 2+iy);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy);
               trait(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               end;
          24 :  begin
               point(ix,iy div 2+iy);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;
          25 :  begin
               point(ix,iy div 2+iy);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               end;
          26 :  begin
               point(ix,iy div 2+iy);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               end;
          27 :  begin
               point(ix,iy div 2+iy);
               point(ix*3,iy div 2+iy);
               pointb(ix*3,iy div 2+iy*2);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               fleche(ix*3,iy div 2+iy,ix*5,iy div 2+iy*2);
               end;
          28 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy);
               end;
          29 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy);
               fleche(ix*2,iy div 2+iy,ix*4,iy div 2+iy*2);
               end;
          30 :  begin
               point(ix*2,iy div 2+iy);
               pointb(ix*2,iy div 2+iy*2);
               point(ix*4,iy div 2+iy);
               pointb(ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy,ix*4,iy div 2+iy*2);
               trait(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy);
               fleche(ix*2,iy div 2+iy*2,ix*4,iy div 2+iy);
               fleche(ix*2,iy div 2+iy,ix*4,iy div 2+iy*2);
               end;
          31 :  begin
               point(ix,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               point(ix*5,iy div 2+iy);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;
          32 :  begin
               point(ix,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               point(ix*5,iy div 2+iy);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               end;
          33 :  begin
               point(ix,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               point(ix*5,iy div 2+iy);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;
          34 :  begin
               point(ix,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               point(ix*5,iy div 2+iy);
               pointb(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               fleche(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               traitsup(ix,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;
          35 :  begin
               point(ix,iy div 2+iy);
               pointb(ix,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               point(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;
          36 :  begin
               point(ix,iy div 2+iy);
               pointb(ix,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               point(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;
          37 :  begin
               point(ix,iy div 2+iy);
               pointb(ix,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               point(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               fleche(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               end;
          38 :  begin
               point(ix,iy div 2+iy);
               pointb(ix,iy div 2+iy*2);
               point(ix*3,iy div 2+iy*2);
               point(ix*5,iy div 2+iy*2);
               trait(ix,iy div 2+iy,ix*3,iy div 2+iy*2);
               trait(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               trait(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               fleche(ix,iy div 2+iy*2,ix*3,iy div 2+iy*2);
               fleche(ix*3,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               traitsup(ix,iy div 2+iy*2,ix*5,iy div 2+iy*2);
               end;

     end;
     end;
end;


initialization
initialise;
finalization
finalise;
end.
